// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"
	json "encoding/json"
	"fmt"

	imagev1 "github.com/openshift/api/image/v1"
	v1 "github.com/openshift/client-go/image/applyconfigurations/image/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	testing "k8s.io/client-go/testing"
)

// FakeImageStreamMappings implements ImageStreamMappingInterface
type FakeImageStreamMappings struct {
	Fake *FakeImageV1
	ns   string
}

var imagestreammappingsResource = schema.GroupVersionResource{Group: "image.openshift.io", Version: "v1", Resource: "imagestreammappings"}

var imagestreammappingsKind = schema.GroupVersionKind{Group: "image.openshift.io", Version: "v1", Kind: "ImageStreamMapping"}

// Apply takes the given apply declarative configuration, applies it and returns the applied imageStreamMapping.
func (c *FakeImageStreamMappings) Apply(ctx context.Context, imageStreamMapping *v1.ImageStreamMappingApplyConfiguration, opts metav1.ApplyOptions) (result *imagev1.ImageStreamMapping, err error) {
	if imageStreamMapping == nil {
		return nil, fmt.Errorf("imageStreamMapping provided to Apply must not be nil")
	}
	data, err := json.Marshal(imageStreamMapping)
	if err != nil {
		return nil, err
	}
	name := imageStreamMapping.Name
	if name == nil {
		return nil, fmt.Errorf("imageStreamMapping.Name must be provided to Apply")
	}
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(imagestreammappingsResource, c.ns, *name, types.ApplyPatchType, data), &imagev1.ImageStreamMapping{})

	if obj == nil {
		return nil, err
	}
	return obj.(*imagev1.ImageStreamMapping), err
}

// Create takes the representation of a imageStreamMapping and creates it.  Returns the server's representation of the status, and an error, if there is any.
func (c *FakeImageStreamMappings) Create(ctx context.Context, imageStreamMapping *imagev1.ImageStreamMapping, opts metav1.CreateOptions) (result *metav1.Status, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(imagestreammappingsResource, c.ns, imageStreamMapping), &metav1.Status{})

	if obj == nil {
		return nil, err
	}
	return obj.(*metav1.Status), err
}
